Set Implicit Arguments.
Require Import Permutation.
Require Import MyTactics.
Require Import Syntax.
Require Import Zap.
Require Import Typing.
Require Import JBasic.

(* This proof is a bit time-consuming, so I am placing it in a separate file. *)

Lemma jpi_zap_permutation:
  forall ys zs,
  Permutation ys zs ->
  forall R K U,
  jpi R K (zap ys U) ->
  jpi R K (zap zs U).
Proof.
  induction 1; simpl; intros; jpi_inversion; eauto with j aac.
Qed.

