(* A list of the modules in a suggested total order of dependency. *)

Require Import MyLogic.
Require Import MyProofIrrelevance.
Require Import MyList.
Require Import MyTactics.
Require Import DeBruijn.
Require Import Environments.
Require Import GetSet.
Require Import GetSetMap.
Require Import MSA.
Require Import MSATactics.
Require Import MSANat.
Require Import MSADiscrete.
Require Import MSABit.
Require Import MSAProduct.
Require Import AllocationMaps.
Require Import MSAAllocationMaps.
Require Import MSADXPermissions.
Require Import MSASig.
Require Import MSAExplode.
Require Import Syntax.
Require Import Zap.
Require Import HeapResources.
Require Import LockResources.
Require Import Resources.
Require Import Sugar.
Require Import WellKindedness.
Require Import Inhabited.
Require Import Heaps.
Require Import LockHeaps.
Require Import Configurations.
Require Import EvaluationContexts.
Require Import Reduction.
Require Import Dup.
Require Import Harmless.
Require Import Row.
Require Import Typing.
Require Import JBasic.
Require Import JWeakening.
Require Import JSubstitution.
Require Import JStrengthening.
Require Import DerivedSubtyping.
Require Import DerivedTyping.
Require Import JAffinity.
Require Import JStability.
Require Import ZapJpi.
Require Import HiddenInvariants.
Require Import Agreement.
Require Import JConf.
Require Import JDuplication.
Require Import JTop.
Require Import JDecomposition.
Require Import JClassification.
Require Import SubsumptionSoundness.
Require Import JCanonicalization.
Require Import SubjectReductionAuxiliary.
Require Import SubjectReductionCaseNew.
Require Import SubjectReductionCaseRead.
Require Import SubjectReductionCaseWrite.
Require Import SubjectReductionCaseFreeze.
Require Import SubjectReductionCaseNewLock.
Require Import SubjectReductionCaseAcquire.
Require Import SubjectReductionCaseRelease.
Require Import SubjectReductionCaseGive.
Require Import SubjectReductionCaseTake.
Require Import SubjectReductionTerms.
Require Import Spawn.
Require Import SubjectReductionSoups.
Require Import ProgressTerms.
Require Import ProgressSoups.
Require Import TypeSoundness.
Require Import DataRaceFreedom.
Require Import STLC.
